﻿Public Class Form1
#Region "Costanti dwRop"
    Public Const BLACKNESS = &H42
    Public Const DSTINVERT = &H550009
    Public Const CAPTUREBLT = &H40000000
    Public Const MERGECOPY = &HC000CA
    Public Const MERGEPAINT = &HBB0226
    Public Const NOMIRRORBITMAP = &H80000000
    Public Const NOTSRCCOPY = &H330008
    Public Const NOTSRCERASE = &H1100A6
    Public Const PATCOPY = &HF00021
    Public Const PATINVERT = &H5A0049
    Public Const PATPAINT = &HFB0A09
    Public Const SRCCOPY = &HCC0020
    Public Const SRCAND = &H8800C6
    Public Const SRCERASE = &H440328
    Public Const SRCINVERT = &H660046
    Public Const SRCPAINT = &HEE0086
    Public Const WHITENESS = &HFF0062
#End Region
#Region "API"
    Public Declare Function BitBlt Lib "gdi32" Alias "BitBlt" (ByVal hDestDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal xSrc As Integer, ByVal ySrc As Integer, ByVal dwRop As Integer) As Integer
    Public Declare Function GetDesktopWindow Lib "user32" () As IntPtr
    Public Declare Function GetDC Lib "user32.dll" (ByVal hWnd As IntPtr) As IntPtr
    Public Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Integer, ByVal hdc As Integer) As Integer
#End Region
    Dim ScalaGrigiMatrice As Imaging.ColorMatrix = New Imaging.ColorMatrix(New Single()() _
              {New Single() {0.3, 0.3, 0.3, 0, 0}, _
               New Single() {0.59, 0.59, 0.59, 0, 0}, _
               New Single() {0.11, 0.11, 0.11, 0, 0}, _
               New Single() {0, 0, 0, 1, 0}, _
               New Single() {0, 0, 0, 0, 1}})
    Dim AttributiImmagine As New Imaging.ImageAttributes

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AttributiImmagine.SetColorMatrix(ScalaGrigiMatrice)
        tmrAggiornamentoImmagine.Start()
    End Sub

    Private Sub tmrRepaint_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrAggiornamentoImmagine.Tick
        AggiornamentoImmagine()
    End Sub
    Private Sub AggiornamentoImmagine()
        Dim oggettoGrafica As Graphics = Me.CreateGraphics
        Dim Y As Integer = Screen.PrimaryScreen.Bounds.Width
        Dim X As Integer = Screen.PrimaryScreen.Bounds.Height
        Dim percentualeZoom As Single = Me.barraScorrimento.Value / 100
        Dim lunghezzaX As Single = (Me.Width - Me.barraScorrimento.Width) * percentualeZoom
        Dim lunghezzaY As Single = (Me.Height - Me.barStato.Height) * percentualeZoom
        Dim offsetX As Single = lunghezzaX \ 2
        Dim offsetY As Single = lunghezzaY \ 2
        Dim areaX As Integer = Me.Width - Me.barraScorrimento.Width
        Dim areaY As Integer = Me.Height - Me.barStato.Height
        Dim bitmap As New Bitmap(CInt(areaX), CInt(areaY))
        Dim grafica As Graphics = Graphics.FromImage(bitmap)
        Me.barStato.Text = "Lo zoom selezionato è " & 101 - Me.barraScorrimento.Value & " X"
        Dim hWndWindow As IntPtr = GetDesktopWindow()
        Dim hdcWindow As IntPtr = GetDC(hWndWindow)
        Dim hdcGraphics As IntPtr = grafica.GetHdc()
        BitBlt(hdcGraphics.ToInt32, 0, 0, areaX, areaY, hdcWindow.ToInt64, Windows.Forms.Cursor.Position.X - offsetX, Windows.Forms.Cursor.Position.Y - offsetY, SRCCOPY Or CAPTUREBLT Or NOMIRRORBITMAP)
        ReleaseDC(hWndWindow.ToInt32, hdcWindow.ToInt32)
        grafica.ReleaseHdc(hdcGraphics)
        oggettoGrafica.DrawImage(bitmap, New Rectangle(0, 0, areaX, areaY), 0, 0, lunghezzaX, lunghezzaY, GraphicsUnit.Pixel)
        oggettoGrafica.Dispose()
    End Sub

    Private Sub NotifyIcon1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick
        If Me.Visible = True Then
            Me.Visible = False
        Else
            Me.Visible = True
        End If
    End Sub

    Private Sub MostraToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MostraToolStripMenuItem.Click
        If Me.Visible = False Then
            Me.Visible = True
        End If
    End Sub

    Private Sub NascondiToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NascondiToolStripMenuItem.Click
        If Me.Visible = True Then
            Me.Visible = False
        End If
    End Sub

    Private Sub InfoSuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InfoSuToolStripMenuItem.Click
        AboutBox1.Show()
    End Sub

    Private Sub EsciToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EsciToolStripMenuItem.Click
        Me.Close()
    End Sub
End Class
